%define maven   0

Name:           jsr-305
Version:        0
Release:        %mkrel 0.5.20090319svn.1
Summary:        Correctness annotations for Java code

Group:          Development/Java
License:        BSD
URL:            http://jsr-305.googlecode.com/
# There has been no official release yet.  This is a snapshot of the Subversion
# repository as of 19 Mar 2009.  Use the following commands to generate the
# tarball:
#   svn export -r 49 http://jsr-305.googlecode.com/svn/trunk jsr-305
#   tar -cvf jsr-305-0.4.20090319.tar jsr-305
#   xz jsr-305-0.4.20090319.tar
Source0:        jsr-305-0.4.20090319.tar.xz
Source1:        jsr-305-ri-build.xml
# bnc#653551
# The URL reffers to New BSD License - used <OWNER> == Bill Pugh, <YEAR> == 2008
Source2:        license
Provides:       jsr305 = %{version}-%{release}
BuildRequires:  java-1.6.0-openjdk-devel
%if %maven
BuildRequires:  jpackage-utils, maven2
BuildRequires:  maven-compiler-plugin
BuildRequires:  maven-install-plugin
BuildRequires:  maven-jar-plugin
BuildRequires:  maven-javadoc-plugin
BuildRequires:  maven-resources-plugin
BuildRequires:  maven-site-plugin
BuildRequires:  maven-surefire-plugin
%else
BuildRequires:  ant
BuildRequires:  java-rpmbuild
%endif

Requires:       java >= 1.5, jpackage-utils

BuildArch:      noarch

%package javadoc
Summary:        Javadoc documentation for %{name}
Group:          Development/Java 
Requires:       jpackage-utils

%description
This package contains reference implementations, test cases, and other
documents for Java Specification Request 305: Annotations for Software Defect
Detection.

%description javadoc
This package contains the API documentation for %{name}.

%prep
%setup -q -n %{name}
%{__cp} -a %{SOURCE1} ri/build.xml
sed -i 's/\r//' sampleUses/pom.xml

%build
%if %maven
export MAVEN_REPO_LOCAL=$(pwd)/.m2/repository
mkdir -p $MAVEN_REPO_LOCAL

mvn-jpp -Dmaven.repo.local=$MAVEN_REPO_LOCAL install
cd ri
mvn-jpp -Dmaven.repo.local=$MAVEN_REPO_LOCAL javadoc:javadoc
%else
export OPT_JAR_LIST=:
export CLASSPATH=
pushd ri
%{ant} -Dant.build.javac.source=1.5 -Dant.build.javac.target=1.5 \
       -Dversion=%{version} -Djava.javadoc=%{_javadocdir}/java
popd
%endif

%install
rm -rf $RPM_BUILD_ROOT

%if %maven
# JAR files
mkdir -p $RPM_BUILD_ROOT%{_javadir}
cp -p ri/target/ri-0.1-SNAPSHOT.jar $RPM_BUILD_ROOT%{_javadir}/%{name}.jar
%else
# jars
%{__mkdir_p} %{buildroot}%{_javadir}
%{__cp} -a ri/jsr-305-%{version}.jar %{buildroot}%{_javadir}/%{name}-%{version}.jar
pushd %{buildroot}%{_javadir}/
%{__ln_s} %{name}-%{version}.jar jsr305-%{version}.jar
popd
(cd %{buildroot}%{_javadir} && for jar in *-%{version}*; do %{__ln_s} ${jar} ${jar/-%{version}/}; done)
%endif

%if %maven
# Javadocs
mkdir -p $RPM_BUILD_ROOT%{_javadocdir}/%{name}
cp -rp ri/target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}/

# pom
mkdir -p $RPM_BUILD_ROOT%{_mavenpomdir}
install -pm 644 ri/pom.xml $RPM_BUILD_ROOT/%{_mavenpomdir}/JPP-%{name}.pom
%add_to_maven_depmap org.apache.maven %{name} %{version} JPP %{name}
%else
# poms
%add_to_maven_depmap org.jsr-305 %{name} %{version} JPP %{name}
 
%{__mkdir_p} %{buildroot}%{_datadir}/maven2/poms
%{__cp} -a ri/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}.pom
 
# javadoc
%{__mkdir_p} %{buildroot}%{_javadocdir}/%{name}-%{version}
%{__cp} -a ri/javadoc/* %{buildroot}%{_javadocdir}/%{name}-%{version}
pushd %{buildroot}%{_javadocdir}
%{__ln_s} %{name}-%{version} %{name}
popd
%endif

%post
%update_maven_depmap

%postun
%update_maven_depmap

%pre javadoc
# workaround for rpm bug 646523 (can be removed in F-17)
[ $1 -gt 1 ] && [ -L %{_javadocdir}/%{name} ] && \
rm -rf $(readlink -f %{_javadocdir}/%{name}) %{_javadocdir}/%{name} || :

%files
%defattr(-,root,root,-)
%doc ri/LICENSE sampleUses
%{_mavenpomdir}/JPP.jsr-305.pom
%{_javadir}/*
%{_mavendepmapfragdir}/jsr-305

%files javadoc
%defattr(-,root,root,-)
%{_javadocdir}/*



%changelog
* Thu Jan 20 2011 dmorgan <dmorgan> 0-0.5.20090319svn.1.mga1
+ Revision: 25686
- Add java-rpmbuild as buildrequire
- Add ant as buildrequire
- Use %%mkrel
- Sync with Opensuse to all to bootstrap
- imported package jsr-305


* Fri Nov 26 2010 Stanislav Ochotnicky <sochotnicky@redhat.com> - 0-0.5.20090319svn
- Fix pom filename (Resolves rhbz#655811)
- Remove tomcat5 BR (not needed anymore)
- Use new maven plugin names
- Remove gcj support
- Few tweaks according to new guidelines
- Make jars and javadocs versionless

* Thu Jan 14 2010 Jerry James <loganjerry@gmail.com> - 0-0.4.20090319svn
- Update to 19 Mar 2009 snapshot
- Compress with xz instead of bzip2
- BR tomcat5, a horrible workaround to solve bz 538868

* Fri Jul 24 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0-0.4.20090203svn
- Rebuilt for https://fedoraproject.org/wiki/Fedora_12_Mass_Rebuild

* Wed Mar  4 2009 Jerry James <loganjerry@gmail.com> - 0-0.3.20090203svn
- Explicitly require OpenJDK to build

* Sat Feb 28 2009 Jerry James <loganjerry@gmail.com> - 0-0.2.20090203svn
- Update to 03 Feb 2009 snapshot

* Wed Feb 25 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0-0.2.20080824svn.1
- Rebuilt for https://fedoraproject.org/wiki/Fedora_11_Mass_Rebuild

* Mon Nov 24 2008 Jerry James <loganjerry@gmail.com> - 0-0.1.20080824svn.1
- Cleaned up summary

* Mon Sep  8 2008 Jerry James <loganjerry@gmail.com> - 0-0.1.20080824svn
- Update to 24 Aug 2008 snapshot

* Mon Aug  4 2008 Jerry James <loganjerry@gmail.com> - 0-0.1.20080721svn
- Update to 21 Jul 2008 snapshot

* Mon Jun 30 2008 Jerry James <loganjerry@gmail.com> - 0-0.1.20080613svn
- Update to 13 Jun 2008 snapshot
- Fix broken URLs
- Include instructions on regenerating the tarball
- Conditionalize the gcj bits

* Mon Jun  2 2008 Jerry James <loganjerry@gmail.com> - 0-0.1.20080527svn
- Update to 27 May 2008 snapshot

* Mon May 12 2008 Jerry James <loganjerry@gmail.com> - 0-0.1.20071105svn
- Initial RPM
